diff --git a/cpp/orm_engine/bind.cpp b/cpp/orm_engine/bind.cpp
index c3e0de7579..26c603522e 100644
--- a/cpp/orm_engine/bind.cpp
+++ b/cpp/orm_engine/bind.cpp
@@ -530,10 +1758,76 @@ void register_orm_engine(nb::module_& parent) {
             return self.order_by_alias(alias, desc);
           },
           nb::arg("alias"), nb::arg("desc") = false)
+      .def(
+          "set_ordering",
+          [](django::orm::QuerySet& self, nb::sequence names) {
+            self.clear_ordering();
+            for (nb::handle value : names) {
+              std::string item = nb::cast<std::string>(value);
+              bool desc = !item.empty() && item.front() == '-';
+              std::string_view name(item);
+              if (desc) {
+                name.remove_prefix(1);
+              }
+              if (name.empty() || name == "?" || !self.order_by(name, desc)) {
+                return false;
+              }
+            }
+            return true;
+          },
+          nb::arg("names"))
+      .def(
+          "with_ordering",
+          [](const django::orm::QuerySet& self,
+             nb::sequence names) -> nb::object {
+            django::orm::QuerySet qs = self.clone();
+            qs.clear_ordering();
+            for (nb::handle value : names) {
+              std::string item = nb::cast<std::string>(value);
+              bool desc = !item.empty() && item.front() == '-';
+              std::string_view name(item);
+              if (desc) {
+                name.remove_prefix(1);
+              }
+              if (name.empty() || name == "?" || !qs.order_by(name, desc)) {
+                return nb::none();
+              }
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("names"))
+      .def(
+          "compile_update_kwargs",
+          [](const django::orm::QuerySet& self, nb::dict kwargs,
+             nb::handle postgres_integer_types) -> nb::object {
+            const auto* model = registered_model(self.model_id());
+            auto updates = model
+                               ? native_updates_from_python(*model, kwargs)
+                               : std::nullopt;
+            if (!updates) {
+              return nb::none();
+            }
+            django::orm::QuerySet qs = self.clone();
+            for (const auto& update : *updates) {
+              const bool added = update.set_null
+                                     ? qs.add_update_null(update.name)
+                                     : qs.add_update(update.name, update.value);
+              if (!added) {
+                return nb::none();
+              }
+            }
+            if (qs.compile().sql.empty()) {
+              return nb::none();
+            }
+            return compile_to_tuple(qs, postgres_integer_types);
+          },
+          nb::arg("kwargs"),
+          nb::arg("postgres_integer_types") = nb::none())
       .def("set_limit", &django::orm::QuerySet::set_limit, nb::arg("n"))
       .def("set_offset", &django::orm::QuerySet::set_offset, nb::arg("n"))
       .def("set_distinct", &django::orm::QuerySet::set_distinct, nb::arg("v"))
-      .def("compile_sql", &compile_to_tuple)
+      .def("compile_sql", &compile_to_tuple,
+           nb::arg("postgres_integer_types") = nb::none())
       .def("base_attnames",
            [](const django::orm::QuerySet& self) {
              return django::native::list_from_strings(self.base_attnames());
diff --git a/cpp/orm_engine/compile.cpp b/cpp/orm_engine/compile.cpp
index c16a660ed4..743948b7de 100644
--- a/cpp/orm_engine/compile.cpp
+++ b/cpp/orm_engine/compile.cpp
@@ -254,8 +254,10 @@ CompiledSql compile_select_inner(const Query& q, const ModelSchema& m) {
     sql += "DISTINCT ";
   }
 
-  std::vector<SelectItem> items = q.select;
-  if (items.empty()) {
+  const std::vector<SelectItem>* items = &q.select;
+  std::vector<SelectItem> default_items;
+  if (items->empty()) {
+    default_items.reserve(m.fields.size());
     for (const auto& f : m.fields) {
       if (f.is_relation() && f.column.empty()) {
         continue;
@@ -265,14 +267,15 @@ CompiledSql compile_select_inner(const Query& q, const ModelSchema& m) {
       }
       SelectItem it;
       it.col.field = f.id;
-      items.push_back(std::move(it));
+      default_items.push_back(std::move(it));
     }
+    items = &default_items;
   }
-  for (std::size_t i = 0; i < items.size(); ++i) {
+  for (std::size_t i = 0; i < items->size(); ++i) {
     if (i) {
       sql += ", ";
     }
-    emit_select_item(sql, order, d, q, m, items[i]);
+    emit_select_item(sql, order, d, q, m, (*items)[i]);
   }
 
   sql += " FROM ";
@@ -306,7 +309,7 @@ CompiledSql compile_select_inner(const Query& q, const ModelSchema& m) {
     sql += " GROUP BY ";
     bool first = true;
     if (q.group_by_all_selected) {
-      for (const auto& it : items) {
+      for (const auto& it : *items) {
         if (it.kind != SelectKind::Column) {
           continue;
         }
diff --git a/cpp/orm_engine/query.cpp b/cpp/orm_engine/query.cpp
index e36df33f04..973e62ddfb 100644
--- a/cpp/orm_engine/query.cpp
+++ b/cpp/orm_engine/query.cpp
@@ -63,9 +63,6 @@ std::optional<CmpOp> cmp_op_from_lookup(std::string_view lookup) {
   if (lookup.empty() || lookup == "exact") {
     return CmpOp::Eq;
   }
-  if (lookup == "iexact") {
-    return CmpOp::Eq;  // emit same; collations later
-  }
   if (lookup == "gt") {
     return CmpOp::Gt;
   }
diff --git a/cpp/orm_engine/query.hpp b/cpp/orm_engine/query.hpp
index 855580bec6..b2e93997d9 100644
--- a/cpp/orm_engine/query.hpp
+++ b/cpp/orm_engine/query.hpp
@@ -37,7 +37,18 @@ struct ParamValue {
     String,
     Bytes,
   };
+  // Logical database type information needed by a driver at the final
+  // Python boundary. PostgreSQL's server-side binding otherwise chooses an
+  // integer OID from the value's magnitude (for example, 7 -> int2), whereas
+  // Django binds an IntegerField as int4 regardless of value.
+  enum class TypeHint : std::uint8_t {
+    Default = 0,
+    PostgresInt2,
+    PostgresInt4,
+    PostgresInt8,
+  };
   Kind kind = Kind::None;
+  TypeHint type_hint = TypeHint::Default;
   bool b = false;
   std::int64_t i = 0;
   double f = 0;
@@ -51,9 +62,11 @@ struct ParamValue {
     p.b = v;
     return p;
   }
-  static ParamValue from_int(std::int64_t v) {
+  static ParamValue from_int(
+      std::int64_t v, TypeHint hint = TypeHint::Default) {
     ParamValue p;
     p.kind = Kind::Int;
+    p.type_hint = hint;
     p.i = v;
     return p;
   }
